<template>
  <div class="task-list">
    <task-info
      v-for="(task, index) in tasks"
      :key="task.task_id"
      :status="task.status"
      :task="task"
      :class="index === tasks.length - 1 ? 'm-0' : ''"
    />
    <api-data endpoint="/task/" invisible v-model="tasks" :interval="3000" />
  </div>
</template>

<script>
import TaskInfo from "@/components/TaskInfo";

export default {
  name: "TaskList",
  components: { TaskInfo },
  data() {
    return {
      tasksValue: [],
      running: false,
    };
  },
  methods: {
    getRunning() {
      // Return whether there are pending tasks or not
      const running = this.tasks.filter(
        (task) => task.status.toLowerCase() === "pending"
      );
      return running.length !== 0;
    },
  },
  computed: {
    tasks: {
      get() {
        return this.tasksValue;
      },
      set(val) {
        this.tasksValue = val;
        this.running = this.getRunning();
      },
    },
  },
};
</script>

<style lang="scss">
div.task-list {
  position: absolute;
  z-index: 5000;
  top: 100%;
  right: 0;
  width: clamp(250px, 440px, 100vw);
  background: white;
  display: none;
  max-height: calc(100vh - 4rem);
  overflow-y: auto;
}

div.task-list-container.task-list-visible div.task-list {
  display: block;
}
</style>
